#define SHOKI_TYPE	"RT"
#define SHOKI_LOG_NAME	SHOKI_LOG_NAME_RT

#define MAX_BIGHASH_SIZE	4096
#define MAX_FACTORIAL		10000
#define MIN_POPULATION		10
#define MAX_LAMBDA		1000

int pf_outformat_d[] =
{
        PF_SRC,
        PF_DST,
        0,
};

char *pf_outdelim_d[] =
{
        " ",
        0,
};

int pf_type_d[] =
{
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	0,
};

struct folist
{
	mpz_t foo;
	int index;
	struct folist *next;
};

struct dlist
{
	u_int64_t diff;
	int count;
	struct dlist *next;
};

int cleanup(int);
void change_log();
void open_dump();
void capture_loop();
void close_dump();
void change_dump();
void clean_kids();

void compile_filters(pcap_t *, bpf_u_int32, int);
void compile_fcodes(char *, bpf_u_int32);
struct bpf_program compile_fcode(int ,bpf_u_int32);
void compile_regexen();

char *getname(const u_char *);
char *intoa(u_int32_t);

void parse_shoki_config(const char *);
char *read_file(char *fname);
void default_formats(int d_f[], char *d_d[], int d_t[]);

pcap_t *fake_pcap(pcap_t *, int);
char *get_filter(char **);

void report();
void birthday_spacings(int);

void read_zdumps(char *, pcap_handler);

void mexp(mpf_t foo, mpf_t x);
