#!/usr/bin/perl
#
# Converts old-stype incident database table into new version

use Pg;
&read_config("/etc/shoki.conf");
&read_config("$INSTALL_PREFIX/$ETCDIR/shoki.conf");
require("$INSTALL_PREFIX/$ETCDIR/collector.conf");
require("$INSTALL_PREFIX/$ETCDIR/db_utils.pl");

$db = 'incidents';
$old_table = 'incidents';
$new_table = 'foobar';

&main();
exit(0);


sub main
{
	my(@format);

	@old_format = &get_sql_format($db, $old_table);
	@new_format = &get_sql_format($db, $new_table);
	&run_query();
}

sub run_query
{
	my($q, $conn, $res, @row, $e, $foo, $bar, @baz, @blah, %old);
	my($q2, $conn2, $e2);

	$q = "select * from $old_table";
	$conn = &db_connect($db);
	$res = $conn->exec($q);
	while(@row = $res->fetchrow)
	{
		%old = ();
		@baz = @old_format;
		@blah = @row;
		while(@blah)
		{
			$foo = shift(@blah);
			$bar = shift(@baz);
			$old{$bar} = $foo;
		}
		$q2 = "insert into $new_table values (";
		foreach $foo (@new_format)
		{
			$old{$foo} =~ s/'/\\'/g;
			$q2 .= "\'" . $old{$foo} . "\',";
		}
		$q2 =~ s/,$//g;
		$q2 .= ")";
		$conn2 = &db_connect($db);
		$conn2->exec($q2);
		$e = $conn2->errorMessage;
		$e && (print "\tError:  $e\n\ton ($q2)\n");
	}
	$e = $conn->errorMessage;
	$e && (print "Error:  $e\n");
}

sub read_config
{
	my($fname) = @_;

	open(FILE, "<$fname") || (die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}


