#!/usr/bin/perl
#
# See the comments in plot.pl
#

&read_config("/etc/shoki.conf");
require("$INSTALL_PREFIX/$ETCDIR/collector.conf");
$logdir = "$INSTALL_PREFIX/central/log";
#$plotdir = "$INSTALL_PREFIX/plot";
$plotdir = "/usr/local/vmware/ids/plot";

&main();
exit(0);

sub main
{
	(-f "$lockfile.plot_reconcile") && exit(1);
	system("$touch $lockfile.plot_reconcile");
	(-d $plotdir) || mkdir($plotdir, 0700);
	&read_files();
	unlink("$lockfile.plot_reconcile");
}

sub read_files
{
	my($foo, $bar, $baz, $i, $j, %p);
	my($fname, $fname_w);
	foreach $foo (@sensors)
	{
		@ports = ();
		(-d "$plotdir/$foo") || mkdir("$plotdir/$foo", 0700);
		opendir(DIR, "$plotdir/$foo") || next;
		while($fname = readdir(DIR))
		{
			($fname =~ /^(\d+)\.(\d+)\.dat$/) || next;
			$fname_w = "$plotdir/$foo/$fname";
			push(@{"port_$1"}, $fname_w);
			push(@ports, $1);
		}
		closedir(DIR);
		foreach $bar (@ports)
		{
			undef(%p);
			open(OUT, "<$plotdir/$foo/$bar.dat") ||
				((-f "$plotdir/$foo/$bar.dat") && next);
			while(<OUT>)
			{
				chomp;
				($i, $j) = split('\s+', $_);
				$p{$i} = $j;
			}
			close(OUT);
			foreach $baz (@{"port_$bar"})
			{
				open(FILE, "<$baz") || next;
				while(<FILE>)
				{
					chomp;
					($i, $j) = split('\s+', $_);
					$p{$i} = $j;
				}
				unlink($baz);
			}
			open(OUT, ">$plotdir/$foo/$bar.dat") || next;
			foreach $i (sort(keys %p))
			{
				print OUT "$i\t$p{$i}\n";
			}
			close(OUT);
		}
	}
}

sub read_config
{
	my($fname) = @_;
	open(FILE, "<$fname") ||
		(die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}

