#!/usr/bin/perl -T
#
# This is a script the sensor can use to send dump files to the central
# data repository.  It should probably be specified as the forced command
# in the ids luser's ~/.ssh/authorized_keys.  More details in the RUNNING
# document.
#

%ENV = ();

umask(007);

$shoki_conf = '/usr/local/net/ids/etc/shoki.conf';

&main();
exit(0);

sub main
{
	&read_config($shoki_conf);
	&read_pending();
	&send_dump();
	&write_pending();
}


sub read_pending
{
	my($foo, $bar, $baz);
	open(FILE, "<$PENDINGFILE") || (die "$0: Couldn't read $PENDINGFILE\n");
	while(<FILE>)
	{
		chomp($foo = $_);
		($bar, $baz) = split('\s+', $foo);
		$logs{$bar} = $baz;
	}
	close(FILE);
}

sub write_pending
{
	my($foo);
	open(FILE, ">$PENDINGFILE") || (die "$0: Couldn't write $PENDINGFILE\n");
	foreach $foo (sort(keys %logs))
	{
		print FILE "$foo\t$logs{$foo}\n";
		print "$foo\t$logs{$foo}\n";
	}
	close(FILE);
}

sub send_dump
{
	my($foo);
	foreach $foo (sort(keys %logs))
	{
		system("$SCP -f $PICKUPDIR/$PARSED.$foo.gz");
		delete($logs{$foo});
		system("$MV $PICKUPDIR/$PARSED.$foo.gz $OLDDIR/$PARSED.$foo.gz");
		last;
	}
}

sub read_config
{
	my($fname) = @_;
	open(FILE, "<$fname") ||
		(die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}
